package RT::CustomFields;

=head3 Modifications LimitToObjectId

Can now take a list; performs a search to get the genealogy for each id passed.

=cut

sub LimitToObjectId {
    my $self = shift;
    my @tmp = @_;

    my $ref_ids = $self->get_all_queues_ids(@tmp);

    # warn "Calling LimitToObjectId with ".join(',',@$ref_ids)."\n";

    $self->Limit(
	ALIAS           => $self->_OCFAlias,
	FIELD           => 'ObjectId',
	OPERATOR        => 'IN',
	VALUE           => \@$ref_ids,
	ENTRYAGGREGATOR => 'OR'
	);
}

sub LimitToGlobalOrObjectId {
    my $self = shift;
    my $global_only = 1;

    if (@_) {
        $self->LimitToObjectId(@_);
        $global_only = 0 if $_[0];
    }

    $self->LimitToObjectId(0) unless $global_only;
}

=head3 Modifications LimitToQueue

Can now take a list; performs a search to get the genealogy for each id passed.

=cut

sub LimitToQueue  {
   my $self = shift;
   my @tmp = @_;

   my @ids = ();
   for my $id (@tmp) {
       my $q = RT::Queue->new($self->CurrentUser);
       $q->Load($id);
       my $ref_ids = $q->Genealogie_ids();
       push @ids,@$ref_ids;
   }

   # warn "Calling LimitToQueue with ".join(',',@ids)."\n";

   $self->Limit (ALIAS => $self->_OCFAlias,
                 ENTRYAGGREGATOR => 'OR',
                 FIELD => 'ObjectId',
                 VALUE => \@ids,
		 OPERATOR => "IN",
       ) if @tmp;
   $self->LimitToLookupType( 'RT::Queue-RT::Ticket' );
}

=head3 get_all_queues_ids(ids) [ ids ]

Takes a list of ids and return a list ref containing :
- the passed ids,
- the ids of all ancestors of passed ids

=cut

sub get_all_queues_ids {
    my $self = shift;
    my @tmp = @_;

    my @ids = ();
    for my $id (@tmp) {
	my $q = RT::Queue->new($self->CurrentUser);
	$q->Load($id);
	next if ! $q->id();
	my $ref_ids = $q->Genealogie_ids();
	push @ids,@$ref_ids;
    }
    if (! @ids) { push @ids,@tmp; }
    return \@ids;

}
1;
