package RT::Record;


# FIXME : maybe replace this property by an attribute,
# using AddAttribute

sub Parent {
    my $self = shift;
    #warn "Calling parent @_";
    my $template_name ='Parent';
    my $value = shift;

    my ($attr) = $self->Attributes->Named($template_name);
    return if ! $attr and ! defined $value;

    if (length $value and defined $value) {
	$self->SetAttribute( Name => $template_name, Content => $value );
	$attr = $self->Attributes->Named($template_name);;
	$self->_Parent($value);
    }

    return $attr->Content;
}

sub SetParent {
    shift->Parent(@_);
}

sub _Parent {
    my $self = shift;
    if (@_) {
	$self->{'_Parent'} = shift;
    }
    return $self->{'_Parent'};
}

sub _ParentObj {
    my $self = shift;
    if (@_) {
	$self->{'_ParentObj'} = shift;
    }
    return $self->{'_ParentObj'};
}

=head2 getParent()

Returns an object (caller's class) if $self::Parent is not null.

=cut

sub getParent {
    my $self = shift;

    # warn "Calling getParent on ".$self->id()." (name : ".$self->Name.")\n";

    return if ! $self->Parent;
    return $self->_ParentObj if $self->_ParentObj;

    my $class = ref($self);
    my $queue = $class->new($self->CurrentUser);
    my $qid = $queue->Load($self->Parent); # FIXME : the term "queue" is inappropriate

    if (! $qid) {
        return ( 0, $self->loc('Queue could not be created') ); # FIXME : the error message is not relevant
    }

    $self->_ParentObj($queue);
    return $queue;
}

=head3 Genealogie : [ objs ]

Returns all the object's parents (and grand-parents, and ...).

=cut

sub Genealogie {
    my $self = shift;

    my $ancestors = [];
    my $parent = $self->getParent;
    return [ $self ] if ! $parent;

    # warn "Calling genealogie on ".$self->Id()." (getting $parent)\n";
    $ancestors = $parent->Genealogie();
    push @$ancestors, $self;

    # warn "Returning ".join(',',@$ancestors)."\n";
    return $ancestors;
}

=head3 Genealogie_ids : [ ids ]

Same as Genealogie, but instead of objects returns ids.

=cut
sub Genealogie_ids {
    my $self = shift;

    my @ids = ();
    my $parents = $self->Genealogie();
    @ids = map { $_->id } @$parents;
    return \@ids;
}

1;
