package RT::Scrip;

=head2 TemplateObj

Retuns an RT::Template object with this Scrip's Template

=cut

sub TemplateObj {
    my $self = shift;
    my $queue = shift;

    my $res = RT::Template->new( $self->CurrentUser );
    $res->LoadByName( Queue => $queue, Name => $self->Template );
    return $res;
}

=head2 Stage

Takes TicketObj named argument and returns scrip's stage when
added to ticket's queue.

=cut

sub Stage {
    my $self = shift;
    my %args = ( TicketObj => undef, @_ );

    my $queue_id = $args{'TicketObj'}->Queue;
    my $queue = RT::Queue->new($self->CurrentUser);
    $queue->Load($queue_id);
    my @queues = @{ $queue->Genealogie_ids() };
    my $rec = RT::ObjectScrip->new( $self->CurrentUser );
    while (! $rec->id() and @queues) {
	$rec->LoadByCols( Scrip => $self->id, ObjectId => pop @queues );
    }
    return $rec->Stage if $rec->id;

    $rec->LoadByCols( Scrip => $self->id, ObjectId => 0 );
    return $rec->Stage if $rec->id;

    return undef;
}

1;
