package RT::Scrips;


=head2 LimitToQueue

Takes a queue id (numerical) as its only argument. Makes sure that 
Scopes it pulls out apply to this queue (or another that you've selected with
another call to this method

=cut

sub LimitToQueue  {
    my $self = shift;
    my @tmp = @_;

    return unless $tmp[0];
    
    my @ids = ();
    for my $id (@tmp) {
	my $q = RT::Queue->new($self->CurrentUser);
	$q->Load($id);
	my $ref_ids = $q->Genealogie_ids();
	push @ids,@$ref_ids;
    }

    warn "Calling LimitToQueue with ".join(',',@ids)."\n";

    my $alias = RT::ObjectScrips->new( $self->CurrentUser )
        ->JoinTargetToThis( $self );

    
    $self->Limit (ALIAS => $alias,
		  FIELD => 'ObjectId',
		  VALUE => \@ids,
		  OPERATOR => "IN",
	);
}

sub LimitToGlobal  {
    my $self = shift;
    return $self->LimitToQueue(0);
}

sub LimitToAdded {
    my $self = shift;
    warn "Calling LimitToAdded (@_)";
    return RT::ObjectScrips->new( $self->CurrentUser )
        ->LimitTargetToAdded( $self => @_ );
}

sub LimitToNotAdded {
    my $self = shift;
    warn "Calling LimitToNotAdded (@_)";
    return RT::ObjectScrips->new( $self->CurrentUser )
        ->LimitTargetToNotAdded( $self => @_ );
}


1;
