package RT::SearchBuilder::AddAndSort;

sub LimitTargetToAdded {
    my $self = shift;
    my $collection = shift;

    my @tmp = @_;

    my @ids = ();
    for my $id (@tmp) {
	my $q = RT::Queue->new($self->CurrentUser);
	$q->Load($id);
	if (! $q->id()) {
	    # this is not a record object...
	    push @ids,$id;
	    next;
	}
	my $ref_ids = $q->Genealogie_ids();
	push @ids,@$ref_ids;
    }

    warn "Calling LimitTargetToAdded with @_, equiv to @ids\n";

    my $alias = $self->JoinTargetToAdded($collection => @ids);

    $collection->Limit(
        ENTRYAGGREGATOR => 'AND',
        ALIAS    => $alias,
        FIELD    => 'id',
        OPERATOR => 'IS NOT',
        VALUE    => 'NULL',
    );
    return $alias;
}

sub LimitTargetToNotAdded {
    my $self = shift;
    my $collection = shift;
    my @tmp = @_;

    my @ids = ();
    for my $id (@tmp) {
	my $q = RT::Queue->new($self->CurrentUser);
	$q->Load($id);
	if (! $q->id()) {
	    # this is not a record object...
	    push @ids,$id;
	    next;
	}
	my $ref_ids = $q->Genealogie_ids();
	push @ids,@$ref_ids;
    }

    my $alias = $self->JoinTargetToAdded($collection => @ids);

    $collection->Limit(
        ENTRYAGGREGATOR => 'AND',
        ALIAS    => $alias,
        FIELD    => 'id',
        OPERATOR => 'IS',
        VALUE    => 'NULL',
    );
    return $alias;
}

1;
